#ifndef WIDGETS_H_
#define WIDGETS_H_

#include <windows.h>

#define WGT_AUTO		(-0x4242)
#define WGT_AUTOMIN(x)	(-x)

struct wgt_window;
struct wgt_widget;

struct wgt_rect {
	int x, y;
	int width, height;
};

typedef void (*wgt_callback)(struct wgt_widget*);

struct wgt_window *wgt_window(const char *title, int width, int height);
void wgt_destroy_window(struct wgt_window *win);
void wgt_destroy_widget(struct wgt_widget *w);

void wgt_enable_widget(struct wgt_widget *w);
void wgt_disable_widget(struct wgt_widget *w);
int wgt_widget_enabled(struct wgt_widget *w);
struct wgt_window *wgt_widget_window(struct wgt_widget *w);
struct wgt_rect *wgt_widget_rect(struct wgt_widget *w, struct wgt_rect *rect);
int wgt_xpos_after(struct wgt_widget *w, int pad);
int wgt_ypos_after(struct wgt_widget *w, int pad);
int wgt_string_size(struct wgt_window *win, const char *s, struct wgt_rect *rect);

struct wgt_widget *wgt_label(struct wgt_window *win, const char *text, int x, int y);
struct wgt_widget *wgt_button(struct wgt_window *win, const char *text, int x, int y,
			int width, int height, wgt_callback clickfunc);
struct wgt_widget *wgt_checkbox(struct wgt_window *win, const char *text, int on,
			int x, int y, int width, int height, wgt_callback modfunc);
struct wgt_widget *wgt_combo(struct wgt_window *win, const char **items, int num_items,
			int sel, int x, int y, int width, int height, wgt_callback modfunc);

void wgt_checkbox_check(struct wgt_widget *w);
void wgt_checkbox_uncheck(struct wgt_widget *w);
int wgt_checkbox_checked(struct wgt_widget *w);

int wgt_combo_setitems(struct wgt_widget *w, const char **items, int num_items);
int wgt_combo_selected(struct wgt_widget *w);
const char *wgt_get_combo_item(struct wgt_widget *w, int idx);

#endif	/* WIDGETS_H_ */
